package fi.em.opplugin;

import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeginOperationTransactionArgs;
import kd.bos.exception.KDBizException;
import kd.bos.servicehelper.BusinessDataServiceHelper;

import java.math.BigDecimal;

public class BusinessProcessingOpPlugin extends AbstractOperationServicePlugIn {
    @Override
    public void beginOperationTransaction(BeginOperationTransactionArgs e) {
        //获取当前操作单据数组
        DynamicObject[] dynamicObjects = e.getDataEntities();
        for (int i = 0; i < dynamicObjects.length; i++) {
            JSONObject object = new JSONObject();
            //当前单头数据包
            DynamicObject info = BusinessDataServiceHelper.loadSingle(dynamicObjects[i].getPkValue(), dynamicObjects[i].getDynamicObjectType().getName());
            String detailtype = info.getString("nckd_detailtype");
            if("A".equals(detailtype)){
                BigDecimal nckdSkmxjehj = info.getBigDecimal("nckd_skmxjehj");
                BigDecimal nckdYsgzjehj = info.getBigDecimal("nckd_ysgzjehj");
                double latitudeDou = nckdSkmxjehj.doubleValue();
                double latitudeDous = nckdYsgzjehj.doubleValue();
                if(latitudeDou!=latitudeDous){
                    throw new KDBizException("收款明细合计金额与应收挂账合计金额不一致！");
                }
            } else if ("B".equals(detailtype)) {
                BigDecimal nckdFkmxjehj = info.getBigDecimal("nckd_fkmxjehj");
                BigDecimal nckdYfgzjehj = info.getBigDecimal("nckd_yfgzjehj");
                double latitudeDou = nckdFkmxjehj.doubleValue();
                double latitudeDous = nckdYfgzjehj.doubleValue();
                if(latitudeDou!=latitudeDous){
                    throw new KDBizException("付款明细合计金额与应付挂账合计金额不一致！");
                }
            }
        }
    }
}
